//+------------------------------------------------------------------+
//|                                Brooky_WPR_Cross_AnalyserV1.1.mq4 |
//|                                          Copyright  2010,Brooky |
//|                               http://forex-indicators.weebly.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010,Brooky"
#property link      "http://forex-indicators.weebly.com"

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1 Red
#property indicator_color2 SteelBlue
#property indicator_color3 Blue
#property indicator_color4 OrangeRed
#property indicator_color5 Gold
#property indicator_level1 -40
#property indicator_level2 -60

#property indicator_levelcolor C'111,111,0'
#property indicator_levelstyle STYLE_DOT
#property indicator_maximum 0
#property indicator_minimum -100


//---- input parameters
extern string    Note_1 = "This will analyse history and then change to analyse current .";
extern string    Note_1a = "IMPORTANT: Leave false when loading Indicator.";
extern string    Note_1b = "Change to true once Indi has loaded.";
extern bool      switch_to_live_update = false;
extern string    Note_2 = "WPR Variables";
extern int       wpr_period=2000;
extern int       wpr_sell_cross=-60;
extern int       wpr_buy_cross=-40;
extern string    Note_3 = "Will write to /experts/files Auto Extension";
extern string    write_file_name="Brooky_Wpr_Analysis_";
extern string    Note_4 = "Limit of Bars Back to Analyse";
extern int       write_bars_back = 100000;
extern string    Note_5 = "Bars to Analyse from Cross Forward";
extern int       bars_back_cross_occured = 21;
extern string    Note_6a = "Basic Spread Add On for Calculations.";
extern string    Note_6b = "If Actual is Higher will use Actual.";
extern int       notional_Broker_spread = 4;
extern string    Note_7 = "To assist finding StDev Trade Limits.";
extern double    stddev_period = 21;
extern string    Note_8 = "To assist finding Bwmfi Limits.";
extern double    bwmfi_period = 21;

//---- buffers
double wpr_buff[];
double buy_buff[];
double sell_buff[];
double write_buff[];
double wpr_buff_back[];


//+------------------------------------------------------------------+
//| Custom indicator initializationinitialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(5);
   SetIndexBuffer(0,wpr_buff);SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(1,wpr_buff_back);SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(2,buy_buff);SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,sell_buff);SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,write_buff);SetIndexStyle(4,DRAW_LINE);
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   Comment("");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
  int start()
    {
     int multiplier=1;
     int digits=MarketInfo(Symbol(),MODE_DIGITS);
     if(digits==5)multiplier=10000;
     if(digits==4)multiplier=1000;
     if(digits==3)multiplier=100;
     if(digits==2)multiplier=10;
     int limit;
     double highnow,lownow,crossclose,diff,stop,highestval,lowestval,tp,stp;
     string pandl = "even";
     int    spread=MarketInfo(Symbol(),MODE_SPREAD)*0.1;
     string sig;
     bool   write_on;
     bool   write = false;
     double ratio=0;
     double stdev;
     double bwmfi_val;
     
     
     int counted_bars=IndicatorCounted();
  //---- check for possible errors
     if(counted_bars<0) return(-1);
  //---- the last counted bar will be recounted
     if(counted_bars>0) counted_bars--;
     limit=Bars-counted_bars;
     if(limit>=write_bars_back)limit=write_bars_back;
 
  //---- main loop
     for(int i=0; i<limit; i++)
       {

     if(spread>notional_Broker_spread){notional_Broker_spread=spread;}
         //--Raw wpr--+
       wpr_buff[i]= iWPR(NULL, 0, wpr_period, i);
       wpr_buff_back[i]= iWPR(NULL, 0, wpr_period, i+bars_back_cross_occured);
       write_buff[i]=-10;

         //--Draw hist--buy--+
     if (iWPR(NULL, 0, wpr_period, i) >= wpr_buy_cross
        && iWPR(NULL, 0, wpr_period, i+1) <= wpr_buy_cross)      
        {         
         buy_buff[i]=wpr_buy_cross;
         sig = "BUY";
        } 
 
      //--Draw hist--sell--+
     if (iWPR(NULL, 0, wpr_period, i) <= wpr_sell_cross
       && iWPR(NULL, 0, wpr_period, i+1)  >= wpr_sell_cross)  
        {
        sell_buff[i]=wpr_sell_cross;
        sig = "SELL";
        }
        
      //--check  x bars back--+
        //--buy--+
     if (iWPR(NULL, 0, wpr_period, i+bars_back_cross_occured) <= wpr_sell_cross
       && iWPR(NULL, 0, wpr_period, i+bars_back_cross_occured+1)  >= wpr_sell_cross)  
        {
        sig = "SELL";
        write=true;
        write_buff[i]=-1;
        }else
        //--sell--+
     if (iWPR(NULL, 0, wpr_period, i+bars_back_cross_occured) >= wpr_buy_cross
        && iWPR(NULL, 0, wpr_period, i+bars_back_cross_occured+1) <= wpr_buy_cross)      
        {
        sig = "BUY";
        write=true;
        write_buff[i]=-1;
         }

      //--Write to text FILE--+
      int handle;
      string currency =Symbol();
      highnow=iHigh(NULL,0,i);
      lownow=iLow(NULL,0,i);
      datetime BarOpen=iTime(NULL,0,i+bars_back_cross_occured) ;
      int hour_now=TimeHour(iTime(NULL,0,i+bars_back_cross_occured));
      if(write_buff[i]==-1)
      {
      write_on=true;
      crossclose=iClose(NULL,0,i+bars_back_cross_occured);
      highestval=High[iHighest(NULL,0,MODE_HIGH,bars_back_cross_occured,i)];
      lowestval=Low[iLowest(NULL,0,MODE_LOW,bars_back_cross_occured,i)];
      stdev=iStdDev(NULL, 0, stddev_period, 0, MODE_LWMA, PRICE_CLOSE, i+bars_back_cross_occured);
      bwmfi_val=iBWMFI(NULL, bwmfi_period, i+bars_back_cross_occured);
      if(sig=="SELL")
      {
      diff=(crossclose-lowestval)*multiplier;
      stop=((highestval-crossclose)*multiplier)+notional_Broker_spread;
      tp=diff;
      stp=NormalizeDouble(tp/stop,2);
      }
      if(sig=="BUY")
      {
      diff=(highestval-crossclose)*multiplier;
      stop= ((crossclose-lowestval)*multiplier)+notional_Broker_spread;
      tp=diff;
      stp=NormalizeDouble(tp/stop,2);
      }
      double profit = (diff-notional_Broker_spread);
      ratio = (diff-notional_Broker_spread)/stop;
      string ratioshow = DoubleToStr(ratio,2);
      
      if(profit<=0)pandl="LOSS";
      if(profit>0 && profit<=10)pandl="Profit to "+DoubleToStr((10-notional_Broker_spread),0);
      if(profit>= 6 && profit<=21)pandl="Profit from 6-21";
      if(profit>=21 && profit<=56)pandl="Profit from 21-56";
      if(profit>=56)pandl="Profit above 56";
      }else write_on=false;
   
   //{}
   
   
    //--live-switch--+
  int scratch=0;
  if(write_on==true && NewBar()==true && switch_to_live_update==true)scratch =1;
  if(write_on==true  && switch_to_live_update==false)scratch =1;

  if(scratch ==1)
  {
  string dynfile =write_file_name+Symbol()+"P"+wpr_period+"BB"+bars_back_cross_occured+".csv";  
  handle=FileOpen(dynfile, FILE_CSV|FILE_READ|FILE_WRITE, ',');//--File created in experts/files/--+
  FileWrite(handle,
  "Currency ",
  "Order Time",
  "Direction",
  "Hour",
  "Order@",
  "Highest next "+bars_back_cross_occured,
  "Lowest next"+bars_back_cross_occured,
  "Win/Lose",
  "P or L",
  "Stop Needed",
  "TP to collect",
  "Spread",
  "P&L Ratio",
  "Tp Stop Ratio",
  "StDev",
  "Bwmfi"
  );
  if(handle>0 )
    {

     FileSeek(handle, 0, SEEK_END);
     FileWrite(handle,
     currency, 
     TimeToStr(BarOpen),
     sig,
     hour_now,
     crossclose,
     highestval,
     lowestval,
     profit,
     pandl,
     stop,
     tp,
     notional_Broker_spread,
     ratioshow,
     stp,
     stdev,
     bwmfi_val
     );
     
     FileClose(handle);
     
     }
    } 
   }     
  }
     return(0);
 //--once per bar thanks to codeguru--+
  bool NewBar()
   {
   static datetime lastbar;
   datetime curbar = Time[0];
   if(lastbar!=curbar)
      {
      lastbar=curbar;
      return(true);
      
      }
      else
      {
      return(false);
      }
   }
//--done--+